using System.Xml.Serialization;
using System.Collections.Generic;

namespace SqlBi.Tools.SqlBulkTool {
    /// <summary>
    /// 
    /// Configuration is a simple class that stores the configuration information of BulkCopy and mantains
    /// the necessary mapping between XML and the in memory object
    /// 
    /// </summary>
    [XmlRootAttribute ("Configuration")]
    public class Configuration {
        [XmlAttribute (DataType = "int")]
        public int MaxNumberOfThreads = 5;

        [XmlArray ("DataBases"), XmlArrayItem ("DataBase", typeof (Configuration.DataBaseInformation))]
        public List<DataBaseInformation> DataBaseInformations;

        public class DataBaseInformation {

            public DataBaseInformation () {
                TableInformations = new List<TableInformation> ();
            }

            [XmlAttribute (DataType = "string")]
            public string Name = "";

            [XmlAttribute (DataType = "boolean")]
            public bool Run = true;

            [XmlAttribute (DataType = "string")]
            public string SourceConnectionString = "";

            [XmlAttribute (DataType = "string")]
            public string DestConnectionString = "";

            [XmlAttribute (DataType = "string")]
            public string DataBaseClass = "SqlServer";

            [XmlArray ("Tables"), XmlArrayItem ("Table", typeof (Configuration.DataBaseInformation.TableInformation))]
            public List<TableInformation> TableInformations;

            [XmlRootAttribute ("TableInformation")]
            public class TableInformation {
                [XmlAttribute (DataType = "string")]
                public string SourceTableName = "";

                [XmlAttribute (DataType = "string")]
                public string DestTableName = "";

                [XmlAttribute (DataType = "string")]
                public string DestTableSchema = "dbo";

                [XmlAttribute (DataType = "string")]
                public string UpdateMinValue;

                [XmlAttribute (DataType = "string")]
                public string UpdateMaxValue;

                [XmlAttribute (DataType = "boolean")]
                public bool TruncateBeforeLoad = true;
            }
        }

        public Configuration () {
            DataBaseInformations = new List<DataBaseInformation> ();
        }
    }
}