using System;
using System.Data.Common;
using System.Data.SqlClient;
using System.Globalization;
using System.Data;

namespace SqlBi.Tools.SqlBulkTool {
    /// <summary>
    /// 
    /// Implementation of DataBaseCopy that uses SqlConnection for the source
    /// 
    /// </summary>
    public class SqlDatabaseCopy : DatabaseCopy {
        public override IDbCommand GetDbCommand (string commandString) {
            SqlConnection conn = new SqlConnection (SourceConnectionString);
            return new SqlCommand (commandString, conn);
        }
        /// <summary>
        /// 
        /// Returns a valid identifier for the SQL dialect implemented. 
        /// The identifier is encapsulated between delimiters and 
        /// internal characters are substituted where necessary
        /// 
        /// </summary>
        /// <param name="identifier">Identifier to normalize</param>
        /// <returns></returns>
        public override string EncapsulateSourceIdentifier (string identifier) {
            return String.Format (CultureInfo.InvariantCulture, "[{0}]", identifier.Replace ("]", "]]"));
        }
    }
}