using System;
using System.IO;
using System.Collections.Generic;
using System.Text;

namespace SqlBi.Tools.SqlBulkTool {
    /// <summary>
    /// 
    /// Simple class that logs on the console various informations
    /// 
    /// it has two method so to make it easy to differentiate between log of Info and of Error (the user
    /// may decide to filter Info and still output Errors)
    /// 
    /// </summary>
    public static class Logger {
        static object LockObject = new object ();   // Dummy object to guarantee work in a multithreaded environment

        /// <summary>
        /// 
        /// Logs a line to the console
        /// 
        /// </summary>
        /// <param name="line"></param>
        private static void Log (string line) {
            lock (LockObject) {
                Console.WriteLine (DateTime.Now.ToLongTimeString () + " - " + line);
            }
        }

        /// <summary>
        /// 
        /// Logs information to the console
        /// 
        /// </summary>
        /// <param name="line"></param>
        public static void LogInfo (string line) {
            Log (line);
        }

        /// <summary>
        /// 
        /// Logs an error to the console
        /// 
        /// </summary>
        /// <param name="line"></param>
        public static void LogError (string line) {
            Log (line);
        }
    }
}
